import math

def find_optimal_colors(k):
    min_theta = 1e100
    for r in range(k, 10 * k):
        theta = 1.0 * math.pow(r,k) * factorial(r - k) \
                * math.pow(2, r) / factorial(r)
        if theta < min_theta:
            min_theta = theta
        else:
            print "k: "+str(k)+"\tr: "+str(r-1)+"\ttheta: "+str(min_theta)+"\tapprox: "+str(int(1.0*k/0.768038))
            return r-1
        
def factorial(n):
    assert(n >= 0 and n == int(n))
    return (n == 0) and 1 or (n * factorial(n - 1))

#for k in range(1, 20):
#    find_optimal_colors(k)

