import math

def combine_selection_bigram_tag_scores(selection_score, lm_score, tag_score):
    lm_tag_score = combine_bigram_tag_scores(lm_score, tag_score)
    return combine_selection_with_bigram_and_tag_scores(selection_score, lm_tag_score)

def combine_selection_with_bigram_and_tag_scores(selection_score, lm_tag_score):
    return selection_score * lm_tag_score

def combine_bigram_tag_scores(lm_score, tag_score):
    return 1.0 * lm_score * (tag_score ** 0.5)


